import pytest
from orchestrator.types import SubscriptionLifecycle

from gso.products import ProductName
from gso.products.product_types.lan_switch_interconnect import LanSwitchInterconnect
from test.workflows import assert_complete, run_workflow


@pytest.mark.workflow()
def test_import_lan_switch_interconnect_success(lan_switch_interconnect_subscription_factory):
    imported_lan_switch_interconnect = lan_switch_interconnect_subscription_factory(is_imported=False)
    result, _, _ = run_workflow(
        "import_lan_switch_interconnect", [{"subscription_id": imported_lan_switch_interconnect}]
    )
    subscription = LanSwitchInterconnect.from_subscription(imported_lan_switch_interconnect)

    assert_complete(result)
    assert subscription.product.name == ProductName.LAN_SWITCH_INTERCONNECT
    assert subscription.status == SubscriptionLifecycle.ACTIVE
    assert subscription.insync is True
